package com.ieng.rms.cntroller;

import com.ieng.rms.entity.AlarmDetailConfig;
import com.ieng.rms.entity.AlarmDetails;
import com.ieng.rms.services.AlarmDetailConfigService;
import com.ieng.rms.util.URL;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@CrossOrigin("*")
@RestController
@RequestMapping(URL.DEFAULT + URL.ALARMS_RELOAD_FROM_REDIS)
public class AlarmsRedisController {
    private final AlarmDetailConfigService alarmDetailConfigService;

    public AlarmsRedisController(AlarmDetailConfigService alarmDetailConfigService) {
        this.alarmDetailConfigService = alarmDetailConfigService;
    }

    @GetMapping("/alarm-details")
    public ResponseEntity<Map<String, Map<String, AlarmDetails>>> getAlarmDetails(@RequestParam String siteId) {
        if (siteId == null || siteId.trim().isEmpty()) {
            return ResponseEntity.badRequest().build();
        }

        Map<String, Map<String, AlarmDetails>> alarmDetailsMap = alarmDetailConfigService.loadAlarmDetailsFromRedisOrDB(siteId);


        return ResponseEntity.ok(alarmDetailsMap);
    }

    @GetMapping("/alarms-config/reload")
    public ResponseEntity<List<AlarmDetailConfig>> reloadAlarmDetailConfig() {
        List<AlarmDetailConfig> updatedConfigList = alarmDetailConfigService.reloadAlarmDetailConfig();

        if (updatedConfigList.isEmpty()) {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(updatedConfigList);
        }

        return ResponseEntity.ok(updatedConfigList);
    }
}
