package com.ieng.rms.config;

import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;
import org.springframework.mail.javamail.JavaMailSender;
import org.springframework.mail.javamail.JavaMailSenderImpl;

import java.util.Properties;

@Configuration
public class MailConfiguration {

    @Primary
    @Qualifier("mailSenderAlert")
    @Bean
    @ConfigurationProperties(prefix = "spring.mail.alert")
    public JavaMailSender mailSenderAlert() {
        return objectCreationJavaMail();
    }

    @Qualifier("mailSenderInfo")
    @Bean
    @ConfigurationProperties(prefix = "spring.mail.info")
    public JavaMailSender mailSenderInfo() {
        return objectCreationJavaMail();
    }

    private JavaMailSenderImpl objectCreationJavaMail() {
        JavaMailSenderImpl mailSender = new JavaMailSenderImpl();
        Properties props = mailSender.getJavaMailProperties();
        props.put("mail.transport.protocol", "smtp");
        props.put("mail.smtp.auth", "true");
        props.put("mail.smtp.starttls.enable", "true");
        props.put("mail.debug", "true");
        return mailSender;
    }

}
