package com.ieng.rms.custom;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;

import java.io.IOException;
import java.math.BigDecimal;
import java.math.RoundingMode;

public class RoundTheDecimal extends JsonSerializer<Number> {
	
	private static final RoundingMode ROUNDING_MODE = RoundingMode.HALF_UP;
	
	protected int precision ;
	
	public RoundTheDecimal( int precision) {
		this.precision = precision;
	}
	
	@Override
	public void serialize( Number value, JsonGenerator gen, SerializerProvider serializers) throws IOException {
		if (value == null) {
			gen.writeNull();
		} else {
			BigDecimal bd = BigDecimal.valueOf(value.doubleValue());
			bd = bd.setScale(precision, ROUNDING_MODE);
			gen.writeNumber(bd);
		}
	}
}
