package com.ieng.rms.dto;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.ieng.rms.entity.AlarmDetailConfig;
import com.ieng.rms.entity.AlarmDetails;
import com.ieng.rms.models.SiteDetailsDTO;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.Optional;

@Data
@AllArgsConstructor
@NoArgsConstructor
public class AlarmDetailReportDto implements Serializable {

    String siteId;
    String siteName;
    String alarmName;
    String fromTime;
    String toTime;
    String elapsedTime;
    Integer alarmStatus;
    String alarmCriticality;
    String initialPacketId;
    String finalPacketId;
    Boolean isNocAlarm;
    String siteAlarmName;
    String comments;
    Boolean acknowledge;

    public AlarmDetailReportDto(AlarmDetails alarmDetails, SiteDetailsDTO siteDetailsDTO, Optional<AlarmDetailConfig> alarmDetailConfig) {
        this.siteId = alarmDetails.getSiteId();
        this.alarmCriticality = alarmDetails.getAlarmCriticality();
        this.fromTime = String.valueOf(alarmDetails.getFromTime());
        this.alarmName = alarmDetails.getAlarmName();
        this.siteName = siteDetailsDTO.getSiteName();
        alarmDetailConfig.ifPresent(detailConfig -> isNocAlarm = detailConfig.getIsNocAlarm());
        this.siteAlarmName = siteId + "_" + alarmName;
        this.acknowledge = false;
    }

    @Override
    public String toString() {
        return "AlarmDetailReportDto{" +
                "siteId='" + siteId + '\'' +
                ", siteName='" + siteName + '\'' +
                ", alarmName='" + alarmName + '\'' +
                ", fromTime='" + fromTime + '\'' +
                ", toTime='" + toTime + '\'' +
                ", elapsedTime='" + elapsedTime + '\'' +
                ", alarmStatus=" + alarmStatus +
                ", alarmCriticality='" + alarmCriticality + '\'' +
                ", initialPacketId='" + initialPacketId + '\'' +
                ", finalPacketId='" + finalPacketId + '\'' +
                ", isNocAlarm=" + isNocAlarm +
                ", siteAlarmName='" + siteAlarmName + '\'' +
                ", comments='" + comments + '\'' +
                ", acknowledge=" + acknowledge +
                '}';
    }

}
