package com.ieng.rms.dto;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.ieng.rms.entity.AlarmDetailConfig;
import com.ieng.rms.entity.AlarmDetails;
import com.ieng.rms.models.SiteDetailsDTO;
import com.ieng.rms.util.DateUtil;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.Optional;

@Data
@AllArgsConstructor
@NoArgsConstructor

public class OldAlarmDetailReportDto implements Serializable {

    private static final long serialVersionUID = -7517629674079551250L;

    Integer id;


    String siteId;


    String siteName;

    String alarmName;

    LocalDateTime fromTime;

    LocalDateTime toTime;

    String elapsedTime;

    Integer alarmStatus;

    String alarmCriticality;

    @JsonIgnore
    String initialPacketId;
    @JsonIgnore
    String finalPacketId;

    Boolean isNocAlarm;

    String siteAlarmName;

    String comments;

    Boolean acknowledge;


    public OldAlarmDetailReportDto(AlarmDetails alarmsDetails, String severity, SiteDetailsDTO siteDetailsDTO) {
        this.siteId = alarmsDetails.getSiteId();
        this.alarmCriticality = alarmsDetails.getAlarmCriticality();
        this.fromTime = alarmsDetails.getFromTime();
        this.alarmName = alarmsDetails.getAlarmMaskingName();
        this.siteName = siteDetailsDTO.getSiteName();
    }

    public OldAlarmDetailReportDto(AlarmDetails alarmDetails, SiteDetailsDTO siteDetailsDTO, Optional<AlarmDetailConfig> alarmDetailConfig) {
        this.siteId = alarmDetails.getSiteId();
        this.alarmCriticality = alarmDetails.getAlarmCriticality();
        this.fromTime = alarmDetails.getFromTime();
        this.alarmName = alarmDetails.getAlarmMaskingName();
        this.siteName = siteDetailsDTO.getSiteName();
        if (alarmDetailConfig.isPresent()) {
            isNocAlarm = alarmDetailConfig.get().getIsNocAlarm();
        }
        this.siteAlarmName = siteId + "_" + alarmName;
        this.acknowledge = false;
    }

    public long getFromMilli() {
        return DateUtil.getMilli(this.fromTime);
    }

}

