package com.ieng.rms.entity;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.time.LocalDateTime;

@Data
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table(name = "alarm_details")
public class AlarmDetails implements Cloneable {

        @Id
        @GeneratedValue(strategy = GenerationType.IDENTITY)
        @Column(name = "id")
        Integer id;

        @Column(name = "site_id")
        String siteId;

        @Column(name = "alarm_name")
        String alarmName;

        @Transient
        String alarmMaskingName;

        @Column(name = "from_time")
        LocalDateTime fromTime;

        @Column(name = "to_time")
        LocalDateTime toTime;

        @Column(name = "elapsed_time")
        String elapsedTime;

        @Column(name = "alarm_status")
        Integer alarmStatus;

        @Column(name = "alarm_criticality")
        String alarmCriticality;

        @JsonIgnore
        @Column(name = "initial_packet_id")
        String initialPacketId;

        @JsonIgnore
        @Column(name = "final_packet_id")
        String finalPacketId;

        @Column(name = "client_id")
        private String clientId;


        public Object clone() throws CloneNotSupportedException { return super.clone(); }
}
