package com.ieng.rms.entity;

import lombok.Data;
import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.UpdateTimestamp;

import javax.persistence.*;
import java.time.LocalDateTime;
import java.util.List;

@Entity
@Data
@Table(name = "rms_site_wise_alarm_config")
public class SiteWiseAlarmMaskingConfig {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id; // Primary Key (can be added if needed for auto-generation)

    @Column(name = "alarm_name", length = 200, nullable = false)
    private String alarmName;

    @Column(name = "alarm_masking_name", length = 200, nullable = false)
    private String alarmMaskingName;

    @Column(name = "criticality", length = 200)
    private String criticality;

    @Column(name = "contract_id", nullable = false)
    private Integer contractId;

    @Column(name = "site_id", length = 200, nullable = false)
    private String siteId;

    @Column(name = "translation", length = 200)
    private String translation;

    @Column(name = "escalation_enable", columnDefinition = "TINYINT(1)", nullable = false)
    private Boolean escalationEnable;

    @Column(name = "alarm_enabled", columnDefinition = "TINYINT(1)", nullable = false)
    private Boolean alarmEnabled;

    @Column(name = "is_noc_alarm", columnDefinition = "TINYINT(1)", nullable = false)
    private Boolean isNocAlarm;

/*    @Column(name = "escalation_id", length = 200, nullable = false)
    private Long escalationId;*/

    @CreationTimestamp
    @Column(name = "created_at", updatable = false)
    private LocalDateTime createdAt;

    @UpdateTimestamp
    @Column(name = "updated_at")
    private LocalDateTime updatedAt;

    @ManyToMany(fetch = FetchType.EAGER)
    @JoinTable(
            name = "alarm_masking_escalation",
            joinColumns = @JoinColumn(name = "alarm_masking_id"),
            inverseJoinColumns = @JoinColumn(name = "escalation_id")
    )
    private List<EscalationEmailEntity> escalations;

}
