package com.ieng.rms.feignclient;

import com.ieng.rms.dto.ContractDTO;
import com.ieng.rms.dto.EscoConfigDTO;
import com.ieng.rms.models.SiteDetailsDTO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

//@FeignClient("rms-service")
@FeignClient(name = "rms-service", url = "${coreServiceUrl}")

public interface RMSCoreClient {
    @RequestMapping(method = RequestMethod.GET, value = "/rms/core/site/site-id")
    ResponseEntity<SiteDetailsDTO> getSiteDetailsBySiteId(@RequestParam("siteId") String siteId);

    @RequestMapping(method = RequestMethod.GET, value = "/rms/core/contract/sites/{contractId}")
    ResponseEntity<List<SiteDetailsDTO>> getAllSiteInfoByContract(@PathVariable("contractId") Integer contractId);

    @RequestMapping(method = RequestMethod.GET, value = "/rms/core/contract/all")
    ResponseEntity<List<ContractDTO>> getAllContracts();


    @RequestMapping(method = RequestMethod.GET, value = "/rms/core/esco/config/protocol-name")
    ResponseEntity<EscoConfigDTO> getEscoConfigurationByProtocol(@RequestParam String protocolName);

}
