package com.ieng.rms.models;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.ieng.rms.custom.RoundUpto0;
import com.ieng.rms.custom.RoundUpto1;
import com.ieng.rms.custom.RoundUpto2;
import com.ieng.rms.util.Constants;
import com.ieng.rms.util.Conversion;
import com.ieng.rms.util.Util;

import javax.transaction.Transactional;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import static com.ieng.rms.util.RedisUtil.generateRedisKey;

@Transactional
public class MonitorScreenModel implements Serializable {
    Map<String, String> alarmConfigMap;
    private String lastUpdated;
    private Integer packetId;
    private String siteId;
    private String siteName;
    private String energyModel;
    private String batteryDischarge;
    private String batteryFuseFail;
    private String blvdAlarm;
    private String dcVoltageLow;
    private String dgBatteryLow;
    private String dgFailToStart;
    private String dgManualMode;
    private String doorOpenAlarm;
    private String loadBreakerFail;
    private String loadOnDG;
    private String loadOnSolar;
    private String lowFuelLevel;
    private String mainsFailure;
    private String mainsOnBatteryDischarge;
    private String rectifierCommunicationFailure;
    private String rectifierFail;
    private String siteOnBattery;
    private String smokeAndFire;
    private String systemBatterytemp4HighAlarm;
    private String temperatureSensorLoseorFaultAlarm;
    private String solarControllerFail;
    private String highTemperature;
    private String region;
    private String zone;
    private String cluster;
    private String solarHybridMode;
    private String clientSiteId;
    private String fanFailDI1;
    private String doorOpenDI2;
    private String smokeFireDI3;
    private String dI4Spare;
    private String dI5Spare;
    private String dI6Spare;
    private String dI7Spare;
    private String dI8Spare;
    private String dI9Spare;
    private String dI10Spare;
    private String dI11Spare;
    private String dI12Spare;
    private String sonicDI13;
    private String sonicDI14;
    private String sonicDI15;
    private String sonicDI16;
    private String dcVoltageHigh;
    @JsonSerialize(using = RoundUpto1.class)
    private float dcV;
    private Integer fuel;
    private String powerSource;
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "##")
    private String soc;
    @JsonSerialize(using = RoundUpto2.class)
    private float dcKW;
    private Integer contractParent;
    private long lastUpdate;
    private boolean isSolar = false;
    private List<String> tickersList = null;
    private String rectifierControllerCommFault;
    private String acemCommFault;
    private String dcemCommFault;
    private String gcuCommFault;
    private String solarEmCommFault;
    private String fuelSensorCommFault;
    // Sonic V2 Live Parameters
    private String gpsLatitude;
    private String gpsLongitude;
    private Integer wifiStatus;
    private String packetType;
    @JsonSerialize(using = RoundUpto1.class)
    private float totalDcLoadCurrent;
    @JsonSerialize(using = RoundUpto1.class)
    private double dcLoadPowerKW;
    private Integer batteryCapacity;
    private Integer batteryCurrent;
    @JsonSerialize(using = RoundUpto0.class)
    private float batteryRunhours;
    @JsonSerialize(using = RoundUpto0.class)
    private float batteryDischargeEnergy;
    @JsonSerialize(using = RoundUpto0.class)
    private double dgPowerKW;
    @JsonSerialize(using = RoundUpto0.class)
    private float dgEnergy;
    @JsonSerialize(using = RoundUpto0.class)
    private float dgRunhours;
    @JsonSerialize(using = RoundUpto1.class)
    private float dgBatteryVoltage;
    @JsonSerialize(using = RoundUpto1.class)
    private double gridPowerKW;
    @JsonSerialize(using = RoundUpto0.class)
    private float gridEnergy;
    @JsonSerialize(using = RoundUpto0.class)
    private float gridRunhours;
    @JsonSerialize(using = RoundUpto1.class)
    private double pvTotalCurrent;
    @JsonSerialize(using = RoundUpto1.class)
    private double pvTotalPowerInKW;
    @JsonSerialize(using = RoundUpto0.class)
    private float pvEnergy;
    @JsonSerialize(using = RoundUpto0.class)
    private float pvRunhours;
    @JsonSerialize(using = RoundUpto0.class)
    private float shelterTemperature;
    @JsonSerialize(using = RoundUpto2.class)
    private float ambientTemperature;
    @JsonSerialize(using = RoundUpto1.class)
    private float batteryCabinetTemperature;
    private String systemControllerFirmwareVersion;
    private String rmsFirmwareVersion;
    // Sonic V2 Live Alarms
    private String batteryFault;
    private String rectifierModuleFail;
    private String pvModuleFail;
    private String dgCommonFault;
    private String surgeProtectionDeviceFail;
    private String liCommFault;
    private String dcAirCon1CommFault;
    private String dcAirCon2CommFault;
    private String dgEmergencyStop;
    private String dgOverLoad;
    private String dgOnWithoutLoud;
    private String dgFailToStop;
    private String dgLlop;
    private String dgHwt;
    private String gpsFixed;
    private String fanFail;
    private String systemInManualMode;
    private String tamperSwitch;
    // private String dcHvModuleDisconnect;
    //private String highTemperatureModuleShutdown;
    private String blvdTrip;
    private String llvdTrip;
    private String dcAirConCompressorFanFault;
    private String singleRectifierFault;
    private String multipleRectifierFault;
    private String fuelAdditionAlarm;
    private String fuelPilferageAlarm;
    // Tanent/Operator Id from packet
    private String clientId;
    private String tenantName;
    @JsonProperty("aCSurgeProtectionDeviceFail")
    private String aCSurgeProtectionDeviceFail;
    @JsonProperty("dCSurgeProtectionDeviceFail")
    private String dCSurgeProtectionDeviceFail;
    private String airConFail;
    private String ebFail;
    @JsonIgnore
    private String moduleSerialNumber1;
    @JsonIgnore
    private String moduleSerialNumber2;
    @JsonIgnore
    private String moduleSerialNumber3;
    @JsonIgnore
    private String moduleSerialNumber4;
    @JsonIgnore
    private String moduleSerialNumber5;
    @JsonIgnore
    private String moduleSerialNumber6;
    @JsonIgnore
    private String moduleSerialNumber7;
    @JsonIgnore
    private String moduleSerialNumber8;
    @JsonIgnore
    private String moduleSerialNumber9;
    @JsonIgnore
    private String moduleSerialNumber10;
    @JsonIgnore
    private String moduleSerialNumber11;
    @JsonIgnore
    private String moduleSerialNumber12;
    @JsonIgnore
    private String moduleSerialNumber13;
    @JsonIgnore
    private String moduleSerialNumber14;
    @JsonIgnore
    private String moduleSerialNumber15;
    @JsonIgnore
    private String moduleSerialNumber16;
    @JsonIgnore
    private String moduleSerialNumber17;
    @JsonIgnore
    private String moduleSerialNumber18;
    @JsonIgnore
    private String moduleSerialNumber19;
    @JsonIgnore
    private String moduleSerialNumber20;
    private String socBattery1;

    public MonitorScreenModel(PacketModel model, SiteDetailsDTO site, String energyModel, Map<String, String> alarmConfigMap) {
        super();


        this.alarmConfigMap = alarmConfigMap;

        this.energyModel = (energyModel != null) ? energyModel : "N/A";

        if (site != null) {

            this.packetId = model.getPacketId();
            this.clientId = model.getClientId();
            this.siteId = site.getSiteId();
            this.siteName = site.getSiteName();
            if (site != null && site.getRegionName() != null) {
                this.region = site.getRegionName();
            }

//			this.zone = sit;
            if (site != null && site.getClusterName() != null) {
                this.cluster = site.getClusterName();
            } else {
                this.cluster = null;
            }
            this.clientSiteId = site.getSiteId();

            if (site.getContractParentId() != null)
                this.contractParent = site.getContractParentId();


        }

        tickersList = new ArrayList<>();
        this.lastUpdated = model.getDateAndTimeStamp().toString();
        this.lastUpdate = model.getDateAndTimeStamp().getTime();
        this.batteryDischarge = model.isBatteryOnDischarge() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.BATTERY_ON_DISCHARGE, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.batteryFuseFail = model.isBatteryFuseFail() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.BATTERY_FUSE_FAIL, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;

        if (model.isdI10Spare() == 1) {
            this.blvdAlarm = Util.getAlarmCriticality(Util.AlarmNames.LLVD_OR_LVBD_TRIP, alarmConfigMap);
            tickersList.add("BlvdTrip");
        } else {
            this.blvdAlarm = Util.AlarmStatus.NORMAL_ALARM;
        }

        if (model.isdCVoltageLow() == 1) {
            this.dcVoltageLow = Util.getAlarmCriticality(Util.AlarmNames.DC_VOLTAGE_LOW, alarmConfigMap);
            tickersList.add("Dc Voltage Low");
        } else {
            this.dcVoltageLow = Util.AlarmStatus.NORMAL_ALARM;
        }

        if (model.isdGBatteryVoltageLow() == 1) {
            this.dgBatteryLow = Util.getAlarmCriticality(Util.AlarmNames.DG_BATTERY_VOLTAGE_LOW, alarmConfigMap);
            tickersList.add("Battery Voltage Low");
        } else {
            this.dgBatteryLow = Util.AlarmStatus.NORMAL_ALARM;
        }
        if (model.isdGFailToStart() == 1) {
            this.dgFailToStart = Util.getAlarmCriticality(Util.AlarmNames.DG_FAIL_TO_START, alarmConfigMap);
            tickersList.add("Dg Fail To Start");
        } else {
            this.dgFailToStart = Util.AlarmStatus.NORMAL_ALARM;
        }
        if (model.isdG12OnInManualMode() == 1) {
            this.dgManualMode = Util.getAlarmCriticality(Util.AlarmNames.DG_RUNNING_IN_MANUAL_MODE, alarmConfigMap);
            tickersList.add("Dg On Manual Mode");
        } else {
            this.dgManualMode = Util.AlarmStatus.NORMAL_ALARM;
        }
        if (model.isLoadBreakerTripped() == 1) {
            this.loadBreakerFail = Util.getAlarmCriticality(Util.AlarmNames.LOAD_BREAKER_TRIPPED, alarmConfigMap);
            tickersList.add("Load Breaker Fail");
        } else {
            this.loadBreakerFail = Util.AlarmStatus.NORMAL_ALARM;
        }
        if (model.isMainsFail() == 1) {
            this.mainsFailure = Util.getAlarmCriticality(Util.AlarmNames.MAINS_FAIL, alarmConfigMap);
            tickersList.add("Main Failure");
        } else {
            this.mainsFailure = Util.AlarmStatus.NORMAL_ALARM;
        }
        if (model.isBatterTempHigh() == 1) {
            this.highTemperature = Util.getAlarmCriticality(Util.AlarmNames.BATTER_TEMP_HIGH, alarmConfigMap);
            tickersList.add("Battery High Temperature");
        } else {
            this.highTemperature = Util.AlarmStatus.NORMAL_ALARM;
        }
        if (model.isRectifierControllerCommFault() != null && model.isRectifierControllerCommFault() == 1) {
            this.rectifierCommunicationFailure = Util.getAlarmCriticality(Util.AlarmNames.RECTIFIER_CONTROLLER_COMMUNICATION_FAULT, alarmConfigMap);
            tickersList.add("Rectifier Communication Failure");
        } else {
            this.rectifierCommunicationFailure = Util.AlarmStatus.NORMAL_ALARM;
        }
	/*	if (model.isSingleRectifierfail() == 0) {
			if (model.isMultipleRectifierFail() == 1) {
				this.rectifierFail = "Minor";
				tickersList.add("Multiple Rectifier Failure");
			} else {
				this.rectifierFail = "Normal";
			}
		} else {
			if (model.isSingleRectifierfail() == 1) {
				this.rectifierFail = "Critical";
				tickersList.add("Single Rectifier Failure");
			} else {
				this.rectifierFail = "Normal";
			}
		}*/
        this.rmsFirmwareVersion = model.getSonicFirmwareVersion();
        this.doorOpenAlarm = model.isDoorOpenDI2() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.DOOR_OPEN, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        if (Util.checkSonicVersion(model.getSonicFirmwareVersion())) {

            this.systemBatterytemp4HighAlarm = model.getSystemBatterytemp4High().equals("1") ? Util.getAlarmCriticality(Util.AlarmNames.SYSTEM_BATTERY_TEMP4_HIGH, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.temperatureSensorLoseorFaultAlarm = model.getTemperatureSensorLoseorFaultAlarm().equals("1") ? Util.getAlarmCriticality(Util.AlarmNames.TEMPERATURE_SENSOR_LOSE_OR_FAULT_ALARM, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.fanFailDI1 = model.getFanFailDI1() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.FAN_FailDI1, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.doorOpenDI2 = model.getDoorOpenDI2() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.DOOR_OPENDI2, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.smokeFireDI3 = model.getSmokeFireDI3() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SMOKE_FIREDI3, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.dI4Spare = model.getdI4Spare() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SPARE_DI4, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.dI5Spare = model.getdI5Spare() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SPARE_DI5, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.dI6Spare = model.getdI6Spare() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SPARE_DI6, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.dI7Spare = model.getdI7Spare() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SPARE_DI7, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.dI8Spare = model.getdI8Spare() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SPARE_DI8, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.dI9Spare = model.getdI9Spare() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SPARE_DI9, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.dI10Spare = model.getdI10Spare() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SPARE_DI10, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.dI11Spare = model.getdI11Spare() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SPARE_DI11, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.dI12Spare = model.getdI12Spare() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SPARE_DI12, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.sonicDI13 = model.getSonicDI13() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SPARE_DI13, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.sonicDI14 = model.getSonicDI14() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SPARE_DI14, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.sonicDI15 = model.getSonicDI15() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SPARE_DI15, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
            this.sonicDI16 = model.getSonicDI16() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SPARE_DI16, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;

            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SYSTEM_BATTERY_TEMP4_HIGH, model.getSiteID()), this.systemBatterytemp4HighAlarm);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.TEMPERATURE_SENSOR_LOSE_OR_FAULT_ALARM, model.getSiteID()), this.temperatureSensorLoseorFaultAlarm);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.FAN_FailDI1, model.getSiteID()), this.fanFailDI1);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DOOR_OPENDI2, model.getSiteID()), this.doorOpenDI2);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SMOKE_FIREDI3, model.getSiteID()), this.smokeFireDI3);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SPARE_DI4, model.getSiteID()), this.dI4Spare);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SPARE_DI5, model.getSiteID()), this.dI5Spare);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SPARE_DI6, model.getSiteID()), this.dI5Spare);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SPARE_DI7, model.getSiteID()), this.dI5Spare);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SPARE_DI8, model.getSiteID()), this.dI5Spare);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SPARE_DI9, model.getSiteID()), this.dI5Spare);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SPARE_DI10, model.getSiteID()), this.dI5Spare);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SPARE_DI11, model.getSiteID()), this.dI5Spare);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SPARE_DI12, model.getSiteID()), this.dI5Spare);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SPARE_DI13, model.getSiteID()), this.dI5Spare);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SPARE_DI14, model.getSiteID()), this.dI5Spare);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SPARE_DI15, model.getSiteID()), this.dI5Spare);
            Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SPARE_DI16, model.getSiteID()), this.dI5Spare);

        }
        this.loadOnDG = model.isLoadOnDG12() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.LOAD_ON_DG, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        if (model.getReserved2LoadOnPv() != null && model.getReserved2LoadOnPv() == 1) {
            isSolar = true;
            this.loadOnSolar = Util.getAlarmCriticality(Util.AlarmNames.LOAD_ON_SOLAR, alarmConfigMap);
        } else {
            this.loadOnSolar = Util.AlarmStatus.NORMAL_ALARM;
        }
        this.lowFuelLevel = model.isdGLowFuelLevel() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.DG_LOW_FUEL_LEVEL, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.siteOnBattery = model.isLoadOnBattery() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SITE_ON_BATTERY, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.smokeAndFire = model.isSmokeFireDI3() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SMOKE_FIRE, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.solarHybridMode = model.getReserved3PvHybridMode() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SOLAR_HYBRID_MODE, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.solarControllerFail = model.isSolarEMCOMMfault() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SOLAR_CONTROLLER_FAIL, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.dcVoltageHigh = model.getDcVoltageHigh() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.DC_VOLTAGE_HIGH, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;

        this.dcV = model.getSystemDcVoltage();
        this.fuel = model.getFuelSensorFuelinliters();
        this.mainsOnBatteryDischarge = getMainsOnBatteryDischarge(model);

        this.rectifierControllerCommFault = model.isRectifierControllerCommFault() != null && model.isRectifierControllerCommFault() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.RECTIFIER_CONTROLLER_COMMUNICATION_FAULT, alarmConfigMap) : "Normal";
        this.acemCommFault = model.getaCEMCommFault() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.ACEM_COMM_FAULT, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.dcemCommFault = model.isdCEMCOMMFault() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.DCEM_COMM_FAULT, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.gcuCommFault = model.isgCUCommFault() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.GCU_COMM_FAULT, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.solarEmCommFault = model.isSolarEMCOMMfault() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.PV_EM_COMM_FAULT, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.fuelSensorCommFault = model.isFuelSensorCommFault() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.FUEL_SENSOR_COMM_FAULT, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;


        /*
        if ((model.isLoadOnBattery() == 1 && model.getReserved3PvHybridMode() == 1 && model.isLoadOnDG12() == 0 && model.isLoadOnDGDO2() == 0 && model.isLoadOnMains() == 0)
                || (model.isLoadOnBattery() == 1 && model.getReserved3PvHybridMode() == 0 && model.getReserved2LoadOnPv() == 0 && model.isLoadOnDG12() == 0 && model.isLoadOnDGDO2() == 0 && model.isLoadOnMains() == 0)) {
            this.powerSource = "Battery";

        } else if ((model.isLoadOnMains() == 1 && model.getReserved3PvHybridMode() == 1 && model.isLoadOnBattery() == 0 && model.isLoadOnDG12() == 0 && model.isLoadOnDGDO2() == 0)
                || (model.isLoadOnMains() == 1 && model.getReserved3PvHybridMode() == 0 && model.getReserved2LoadOnPv() == 0 && model.isLoadOnBattery() == 0 && model.isLoadOnDG12() == 0 && model.isLoadOnDGDO2() == 0)) {
            this.powerSource = "CP";

        } else if (((model.isLoadOnDG12() == 1 || model.isLoadOnDGDO2() == 1) && model.getReserved3PvHybridMode() == 1 && model.isLoadOnMains() == 0 && model.isLoadOnBattery() == 0)
                || ((model.isLoadOnDG12() == 1 || model.isLoadOnDGDO2() == 1) && model.getReserved3PvHybridMode() == 0 && model.getReserved2LoadOnPv() == 0 && model.isLoadOnMains() == 0 && model.isLoadOnBattery() == 0)) {
            this.powerSource = "DG";

        } else if ((model.getReserved2LoadOnPv() == 1 && model.isLoadOnDG12() == 0 && model.isLoadOnDGDO2() == 0 && model.getReserved3PvHybridMode() == 0 && model.isLoadOnMains() == 0 && model.isLoadOnBattery() == 0)) {
            this.powerSource = "Solar";

        } else {
            this.powerSource = "N/A";
        }
         */

        this.powerSource = checkPowerSource(model);

        float avgSoc = getAverageSOC(model);
//        this.soc = String.valueOf(avgSoc);
        this.soc = String.valueOf(model.getSocBattery1());
        Float totalDcKw = (model.getTotalLoadCurrent() * model.getSystemDcVoltage()) / 1000;
        this.dcKW = Conversion.round(totalDcKw, 2);


        this.gpsLatitude = model.getGpsLatitude();
        this.gpsLongitude = model.getGpsLongitude();
        this.wifiStatus = model.getSonicWifiStatus();
        this.packetType = model.getPacketType();
        this.totalDcLoadCurrent = model.getTotalLoadCurrent();
        this.dcLoadPowerKW = calculateDcLoadPowerKw(model);
        this.batteryCapacity = model.getBattery1Capacity() + model.getBattery2Capacity() + model.getBattery3Capacity() + model.getBattery4Capacity();
        this.batteryCurrent = model.getBatteryCurrent();
        this.batteryRunhours = model.getReserved5();
        this.batteryDischargeEnergy = model.getReserved4();
        this.dgPowerKW = calculateDgPowerKw(model);
        this.dgEnergy = model.getReserved10();
        this.dgRunhours = model.getReserved11();
        this.dgBatteryVoltage = model.getdG1BatteryVoltage();
        this.gridPowerKW = calculateGridPowerKw(model);
        this.gridEnergy = model.geteBInputGridEnergy();
        this.gridRunhours = model.getGridRunHour();
        this.pvTotalCurrent = calculatePvTotalCurrent(model);
        this.pvTotalPowerInKW = calculatePvTotalPowerKw(model);
        this.pvEnergy = model.getPvEnergy();
        this.pvRunhours = model.getPvRunHours();
        this.shelterTemperature = model.getSystemCabinetTemperature();
        this.ambientTemperature = model.getOutdoorEnvironmentTemperature();
        this.batteryCabinetTemperature = model.getBattery1CabinetTemperature();
        this.systemControllerFirmwareVersion = model.getSystemControllerSoftwareVersion();


        //New Alarms

        this.batteryFault = checkBatteryFault(model);
        this.rectifierModuleFail = model.isdI8Spare() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.RECTIFIER_MODULE_FAIL, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.pvModuleFail = checkPvModuleFail(model);
        this.dgCommonFault = model.getdGCommonFault() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.DG_COMMON_FAULT, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.surgeProtectionDeviceFail = model.isdI12Spare() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SURGE_PROTECTION_DEVICE_FAIL, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.liCommFault = checkLiCommFault(model);
        this.dcAirCon1CommFault = model.isdCAirCon1CommFault() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.DC_AIRCON1_COMM_FAULT, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.dcAirCon2CommFault = model.isdCAirCon2CommFault() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.DC_AIRCON_2_COMM_FAULT, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.dgEmergencyStop = model.isdGEmergencyStop() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.DG_EMERGENCY_STOP, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.dgOverLoad = model.isdGOverLoad() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.DG_OVER_LOAD, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.dgOnWithoutLoud = model.isdG12OnWithoutLoad() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.DG_ON_WITHOUT_LOAD, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.dgFailToStop = model.isdGFailToStop() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.DG_FAIL_TO_STOP, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.dgLlop = model.isLowLubeOilPressure() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.DG_LLOP, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.dgHwt = model.isdGHwtHct() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.DG_HWT, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.gpsFixed = model.getGpsFix() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.GPS_FIXED, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.fanFail = model.isFanFailDI1() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.FAN_FAIL, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.systemInManualMode = model.isdI4Spare() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SYSTEM_IN_MANUAL_MODE, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        tamperSwitch = model.isTamperSwitchforModem() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.TAMPER_SWITCH, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        // this.dcHvModuleDisconnect = checkDcHvModuleDisconnect(model);
        //this.highTemperatureModuleShutdown = checkHighTemperatureModuleShutdown(model);
        this.blvdTrip = model.isBlvdTrip() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.BLVD_TRIP, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.llvdTrip = model.isLvdDisconnect() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.LLVD_TRIP, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.dcAirConCompressorFanFault = checkDcAirConCompressorFanFault(model);
        this.singleRectifierFault = model.isSingleRectifierfail() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SINGLE_RECTIFIER_FAIL, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.multipleRectifierFault = model.isMultipleRectifierFail() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.MULTIPLE_RECTIFIER_FAIL, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.fuelAdditionAlarm = model.getFuelAdditionAlarm() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.FUEL_ADDITION, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.fuelPilferageAlarm = model.getFuelPilferageAlarm() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.FUEL_PILFERAGE, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;

        this.tenantName = this.clientId.endsWith("-GT") ? "Globe" : this.clientId.endsWith("-SC") ? "Smart" : "N/A";

        this.aCSurgeProtectionDeviceFail = model.isaCSurgeProtectionDeviceFail() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.AC_SURGE_PROTECTION_DEVICE_FAIL, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.dCSurgeProtectionDeviceFail = model.isdCSurgeProtectionDeviceFail() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.DC_SURGE_PROTECTION_DEVICE_FAIL, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.airConFail = model.getSonicDI16() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.AIRCON_FAIL, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.ebFail = model.getSystemControllerDI5() == 1 ? Util.getAlarmCriticality(Util.AlarmNames.SYSTEM_CONTROLLER_DI5, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;
        this.socBattery1 = ((int) model.getSocBattery1()) <= 28 ? Util.getAlarmCriticality(Util.AlarmNames.SOC_BATTERY_1, alarmConfigMap) : Util.AlarmStatus.NORMAL_ALARM;

        setAlarmWiseStatusMap(model);

        //set Rectifier Values

        this.moduleSerialNumber1 = model.getModuleSerialNumber1();
        this.moduleSerialNumber2 = model.getModuleSerialNumber2();
        this.moduleSerialNumber3 = model.getModuleSerialNumber3();
        this.moduleSerialNumber4 = model.getModuleSerialNumber4();
        this.moduleSerialNumber5 = model.getModuleSerialNumber5();
        this.moduleSerialNumber6 = model.getModuleSerialNumber6();
        this.moduleSerialNumber7 = model.getModuleSerialNumber7();
        this.moduleSerialNumber8 = model.getModuleSerialNumber8();
        this.moduleSerialNumber9 = model.getModuleSerialNumber9();
        this.moduleSerialNumber10 = model.getModuleSerialNumber10();
        this.moduleSerialNumber11 = model.getModuleSerialNumber11();
        this.moduleSerialNumber12 = model.getModuleSerialNumber12();
        this.moduleSerialNumber13 = model.getModuleSerialNumber13();
        this.moduleSerialNumber14 = model.getModuleSerialNumber14();
        this.moduleSerialNumber15 = model.getModuleSerialNumber15();
        this.moduleSerialNumber16 = model.getModuleSerialNumber16();
        this.moduleSerialNumber17 = model.getModuleSerialNumber17();
        this.moduleSerialNumber18 = model.getModuleSerialNumber18();
        this.moduleSerialNumber19 = model.getModuleSerialNumber19();
        this.moduleSerialNumber20 = model.getModuleSerialNumber20();


        this.gpsLatitude = site.getLatitude();
        this.gpsLongitude = site.getLongitude();

        if (model.getGpsLatitude() != null && !model.getGpsLatitude().equals("0")) {
            this.gpsLatitude = model.getGpsLatitude();
        }

        if (model.getGpsLongitude() != null && !model.getGpsLatitude().equals("0")) {
            this.gpsLongitude = model.getGpsLongitude();
        }


    }

    public String getDcVoltageHigh() {
        return dcVoltageHigh;
    }

    public void setDcVoltageHigh(String dcVoltageHigh) {
        this.dcVoltageHigh = dcVoltageHigh;
    }

    public String getFanFailDI1() {
        return fanFailDI1;
    }

    public void setFanFailDI1(String fanFailDI1) {
        this.fanFailDI1 = fanFailDI1;
    }

    public String getDoorOpenDI2() {
        return doorOpenDI2;
    }

    public void setDoorOpenDI2(String doorOpenDI2) {
        this.doorOpenDI2 = doorOpenDI2;
    }

    public String getSmokeFireDI3() {
        return smokeFireDI3;
    }

    public void setSmokeFireDI3(String smokeFireDI3) {
        this.smokeFireDI3 = smokeFireDI3;
    }

    public String getdI4Spare() {
        return dI4Spare;
    }

    public void setdI4Spare(String dI4Spare) {
        this.dI4Spare = dI4Spare;
    }

    public String getdI5Spare() {
        return dI5Spare;
    }

    public void setdI5Spare(String dI5Spare) {
        this.dI5Spare = dI5Spare;
    }

    private String checkDcAirConCompressorFanFault(PacketModel model) {
        String criticality = Util.AlarmStatus.NORMAL_ALARM;
        if (model.isDcAircon1CompressorFaultFanfault() == 1 || model.isDcAircon2CompressorFaultFanfault() == 1) {
            criticality = Util.getAlarmCriticality(Util.AlarmNames.DC_AIRCON_COMPRESSOR_FAN_FAULT, alarmConfigMap);
        }
        return criticality;
    }



 /*   private String checkHighTemperatureModuleShutdown(PacketModel model) {
        String criticality = Util.AlarmStatus.NORMAL_ALARM;
        if(model.isHighTempShutdownModule1() == 1 || model.isHighTempShutdownModule2() == 1 || model.isHighTempShutdownModule3() == 1
                || model.isHighTempShutdownModule4() == 1 || model.isHighTempShutdownModule5() == 1 || model.isHighTempShutdownModule6() == 1
                || model.isHighTempShutdownModule7() == 1 || model.isHighTempShutdownModule8() == 1 || model.isHighTempShutdownModule9() == 1
                || model.isHighTempShutdownModule10() == 1 || model.isHighTempShutdownModule11() == 1 || model.isHighTempShutdownModule12() == 1
                || model.isHighTempShutdownModule13() == 1 || model.isHighTempShutdownModule14() == 1 || model.isHighTempShutdownModule15() == 1
                || model.isHighTempShutdownModule16() == 1 || model.isHighTempShutdownModule17() == 1 || model.isHighTempShutdownModule18() == 1
                || model.isHighTempShutdownModule19() == 1 || model.isHighTempShutdownModule20() == 1 ){

            criticality = Util.getAlarmCriticality(Util.AlarmNames.HIGH_TEMP_MODULE_SHUTDOWN,alarmConfigMap);
        }
        return criticality;
    }*/

  /*  private String checkDcHvModuleDisconnect(PacketModel model) {
        String criticality = Util.AlarmStatus.NORMAL_ALARM;
        if(model.isDcHvDisconnectModule1()  == 1 || model.isDcHvDisconnectModule2()  == 1 || model.isDcHvDisconnectModule3()  == 1
                || model.isDcHvDisconnectModule4()  == 1 || model.isDcHvDisconnectModule5()  == 1 || model.isDcHvDisconnectModule6()  == 1
                || model.isDcHvDisconnectModule7()  == 1 || model.isDcHvDisconnectModule8()  == 1 || model.isDcHvDisconnectModule9()  == 1
                || model.isDcHvDisconnectModule10()  == 1 || model.isDcHvDisconnectModule11()  == 1 || model.isDcHvDisconnectModule12()  == 1
                || model.isDcHvDisconnectModule13()  == 1 || model.isDcHvDisconnectModule14()  == 1 || model.isDcHvDisconnectModule15()  == 1
                || model.isDcHvDisconnectModule16()  == 1 || model.isDcHvDisconnectModule17()  == 1 || model.isDcHvDisconnectModule18()  == 1
                || model.isDcHvDisconnectModule19()  == 1 || model.isDcHvDisconnectModule20()  == 1 ){

            criticality = Util.getAlarmCriticality(Util.AlarmNames.DC_HV_MODULE_DISCONNECT,alarmConfigMap);
        }
        return criticality;
    }*/

    private String checkLiCommFault(PacketModel model) {
        String criticality = Util.AlarmStatus.NORMAL_ALARM;
        if (model.getLiCommFault1().equals("1") || model.getLiCommFault2().equals("1") || model.getLiCommFault3().equals("1")
                || model.getLiCommFault4().equals("1") || model.getLiCommFault5().equals("1") || model.getLiCommFault6().equals("1")
                || model.getLiCommFault7().equals("1") || model.getLiCommFault8().equals("1") || model.getLiCommFault9().equals("1")
                || model.getLiCommFault10().equals("1") || model.getLiCommFault11().equals("1") || model.getLiCommFault12().equals("1")
                || model.getLiCommFault13().equals("1") || model.getLiCommFault14().equals("1") || model.getLiCommFault15().equals("1")
                || model.getLiCommFault16().equals("1")) {

            criticality = Util.getAlarmCriticality(Util.AlarmNames.LI_COMM_FAULT, alarmConfigMap);
        }

        return criticality;
    }

    private String checkPvModuleFail(PacketModel model) {
        String criticality = Util.AlarmStatus.NORMAL_ALARM;
        if (model.isPv1ModuleStatus() == 1 || model.isPv2ModuleStatus() == 1 || model.isPv3ModuleStatus() == 1 || model.isPv4ModuleStatus() == 1
                || model.isPv5ModuleStatus() == 1 || model.isPv6ModuleStatus() == 1 || model.isPv7ModuleStatus() == 1 || model.isPv8ModuleStatus() == 1
                || model.isPv9ModuleStatus() == 1 || model.isPv10ModuleStatus() == 1 || model.isPv11ModuleStatus() == 1 || model.isPv12ModuleStatus() == 1) {
            criticality = Util.getAlarmCriticality(Util.AlarmNames.PV_MODULE_FAIL, alarmConfigMap);
        }

        return criticality;
    }

    private String checkBatteryFault(PacketModel model) {
        String criticality = Util.AlarmStatus.NORMAL_ALARM;
        if (model.getLiBattStatus1().equals("4") || model.getLiBattStatus2().equals("4") || model.getLiBattStatus3().equals("4")
                || model.getLiBattStatus4().equals("4") || model.getLiBattStatus5().equals("4") || model.getLiBattStatus6().equals("4")
                || model.getLiBattStatus7().equals("4") || model.getLiBattStatus8().equals("4") || model.getLiBattStatus9().equals("4")
                || model.getLiBattStatus10().equals("4") || model.getLiBattStatus11().equals("4") || model.getLiBattStatus12().equals("4")
                || model.getLiBattStatus13().equals("4") || model.getLiBattStatus14().equals("4") || model.getLiBattStatus15().equals("4")
                || model.getLiBattStatus16().equals("4")) {
            criticality = Util.getAlarmCriticality(Util.AlarmNames.BATTERY_FAULT, alarmConfigMap);
        }

        return criticality;
    }

    private float getAverageSOC(PacketModel model) {
        float totalSoc = model.getSocBattery1() + model.getSocBattery2() + model.getSocBattery3()
                + model.getSocBattery4();
        int occurances = 0;
        occurances += getOneIfGreateThanZero(model.getSocBattery1());
        occurances += getOneIfGreateThanZero(model.getSocBattery2());
        occurances += getOneIfGreateThanZero(model.getSocBattery3());
        occurances += getOneIfGreateThanZero(model.getSocBattery4());

        return totalSoc / occurances;
    }

    public double calculateDcLoadPowerKw(PacketModel model) {
        return (calculateKW(model.getTotalLoadCurrent() * model.getSystemDcVoltage()));
    }

    public double calculateDgPowerKw(PacketModel model) {
        return (calculateKW(model.getdG12RPhasePower() + model.getdG12YPhasePower() + model.getdG12BPhasePower()));
    }

    public double calculateGridPowerKw(PacketModel model) {
        return ((model.geteBRPhasePower() + model.geteBYPhasePower() + model.geteBBPhasePower()));
    }

    /*    public double calculatePvTotalCurrent(PacketModel model) {
            return ((model.getPv1OutputCurrent() + model.getPv2OutputCurrent()
                    + model.getPv3OutputCurrent() + model.getPv4OutputCurrent()
                    + model.getPv5OutputCurrent() + model.getPv6OutputCurrent()
                    + model.getPv7OutputCurrent() + model.getPv8OutputCurrent()
                    + model.getPv9OutputCurrent() + model.getPv10OutputCurrent()
                    + model.getPv11OutputCurrent() + model.getPv12OutputCurrent()));
        }*/
    public double calculatePvTotalCurrent(PacketModel model) {
        double totalPvCurrent;
        if (Util.checkSonicVersion(model.getSonicFirmwareVersion())) {
            totalPvCurrent = model.getPvTotalOutputCurrent();
        } else {
            totalPvCurrent = ((model.getPv1OutputCurrent() + model.getPv2OutputCurrent()
                    + model.getPv3OutputCurrent() + model.getPv4OutputCurrent()
                    + model.getPv5OutputCurrent() + model.getPv6OutputCurrent()
                    + model.getPv7OutputCurrent() + model.getPv8OutputCurrent()
                    + model.getPv9OutputCurrent() + model.getPv10OutputCurrent()
                    + model.getPv11OutputCurrent() + model.getPv12OutputCurrent()));
        }
        return totalPvCurrent;
    }

    public double calculatePvTotalPowerKw(PacketModel model) {
        return (calculateKW(model.getPvTotalOutputCurrent() * model.getPvOutputVoltage()));
    }

    public String checkPowerSource(PacketModel model) {
        String powerSource = "N/A";
        if (model.getReserved3PvHybridMode() == 0 && (model.isLoadOnMains() == 1 && model.getaCEMCommFault() == 0)) {
            powerSource = "CP";
        }
        // DG old logic
        /*else if(model.getReserved3PvHybridMode() ==0 && ((model.getReserved9() == 1  &&  model.isgCUCommFault() == 0) || (model.isgCUCommFault() == 1 && model.isLoadOnDG12() == 1))){
            powerSource = "DG";
        }*/
        else if (model.getReserved3PvHybridMode() == 0 && (model.getReserved9() == 1 || model.isLoadOnDG12() == 1)) {
            powerSource = "DG";
        } else if (model.isLoadOnBattery() == 1 && model.getReserved3PvHybridMode() == 0) {
            powerSource = "Battery";
        } else if (model.getReserved2LoadOnPv() == 1) {
            powerSource = "Solar";
        } else if (model.getReserved3PvHybridMode() == 1) {
            powerSource = "Hybrid";
        }
        return powerSource;
    }

    public String getMainsOnBatteryDischarge(PacketModel model) {
        String criticality = Util.AlarmStatus.NORMAL_ALARM;
        if (model.isLoadOnMains() == 1 && model.isBatteryOnDischarge() == 1) {
            criticality = Util.getAlarmCriticality(Util.AlarmNames.MAINS_ON_BATTERY_DISCHARGE, alarmConfigMap);
        }
        return criticality;
    }

    public void setAlarmWiseStatusMap(PacketModel model) {
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.BATTERY_ON_DISCHARGE, model.getSiteID()), this.batteryDischarge);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.BATTERY_FUSE_FAIL, model.getSiteID()), this.batteryFuseFail);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.LLVD_OR_LVBD_TRIP, model.getSiteID()), this.blvdAlarm);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DC_VOLTAGE_LOW, model.getSiteID()), this.dcVoltageLow);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DG_BATTERY_VOLTAGE_LOW, model.getSiteID()), this.dgBatteryLow);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DG_FAIL_TO_START, model.getSiteID()), this.dgFailToStart);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DG_RUNNING_IN_MANUAL_MODE, model.getSiteID()), this.dgManualMode);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.LOAD_BREAKER_TRIPPED, model.getSiteID()), this.loadBreakerFail);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.MAINS_FAIL, model.getSiteID()), this.mainsFailure);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.BATTER_TEMP_HIGH, model.getSiteID()), this.highTemperature);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.RECTIFIER_CONTROLLER_COMMUNICATION_FAULT, model.getSiteID()), this.rectifierCommunicationFailure);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DOOR_OPEN, model.getSiteID()), this.doorOpenAlarm);
        /*
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SYSTEM_BATTERY_TEMP4_HIGH, model.getSiteID()),this.systemBatterytemp4HighAlarm);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.TEMPERATURE_SENSOR_LOSE_OR_FAULT_ALARM, model.getSiteID()),this.temperatureSensorLoseorFaultAlarm);*/
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.LOAD_ON_DG, model.getSiteID()), this.loadOnDG);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.LOAD_ON_SOLAR, model.getSiteID()), this.loadOnSolar);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DG_LOW_FUEL_LEVEL, model.getSiteID()), this.lowFuelLevel);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SITE_ON_BATTERY, model.getSiteID()), this.siteOnBattery);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SMOKE_FIRE, model.getSiteID()), this.smokeAndFire);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SOLAR_HYBRID_MODE, model.getSiteID()), this.solarHybridMode);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.MAINS_ON_BATTERY_DISCHARGE, model.getSiteID()), this.mainsOnBatteryDischarge);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SOLAR_CONTROLLER_FAIL, model.getSiteID()), this.solarControllerFail);
//        Constants.siteWiseAlarmsStatusMap.put(Util.generateRedisKey(Util.AlarmNames.RECTIFIER_CONTROLLER_COMMUNICATION_FAULT,model.getSiteID()),this.rectifierControllerCommFault);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.ACEM_COMM_FAULT, model.getSiteID()), this.acemCommFault);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DCEM_COMM_FAULT, model.getSiteID()), this.dcemCommFault);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.GCU_COMM_FAULT, model.getSiteID()), this.gcuCommFault);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.PV_EM_COMM_FAULT, model.getSiteID()), this.solarEmCommFault);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.FUEL_SENSOR_COMM_FAULT, model.getSiteID()), this.fuelSensorCommFault);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.BATTERY_FAULT, model.getSiteID()), this.batteryFault);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.RECTIFIER_MODULE_FAIL, model.getSiteID()), this.rectifierModuleFail);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.PV_MODULE_FAIL, model.getSiteID()), this.pvModuleFail);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DG_COMMON_FAULT, model.getSiteID()), this.dgCommonFault);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SURGE_PROTECTION_DEVICE_FAIL, model.getSiteID()), this.surgeProtectionDeviceFail);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.LI_COMM_FAULT, model.getSiteID()), this.liCommFault);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DC_AIRCON1_COMM_FAULT, model.getSiteID()), this.dcAirCon1CommFault);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DC_AIRCON_2_COMM_FAULT, model.getSiteID()), this.dcAirCon2CommFault);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DG_EMERGENCY_STOP, model.getSiteID()), this.dgEmergencyStop);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DG_OVER_LOAD, model.getSiteID()), this.dgOverLoad);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DG_ON_WITHOUT_LOAD, model.getSiteID()), this.dgOnWithoutLoud);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DG_FAIL_TO_STOP, model.getSiteID()), this.dgFailToStop);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DG_LLOP, model.getSiteID()), this.dgLlop);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DG_HWT, model.getSiteID()), this.dgHwt);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.GPS_FIXED, model.getSiteID()), this.gpsFixed);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.FAN_FAIL, model.getSiteID()), this.fanFail);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SYSTEM_IN_MANUAL_MODE, model.getSiteID()), this.systemInManualMode);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.TAMPER_SWITCH, model.getSiteID()), this.tamperSwitch);
       /* Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DC_HV_MODULE_DISCONNECT,model.getSiteID()),this.dcHvModuleDisconnect);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.HIGH_TEMP_MODULE_SHUTDOWN,model.getSiteID()),this.highTemperatureModuleShutdown);*/
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.BLVD_TRIP, model.getSiteID()), this.blvdTrip);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.LLVD_TRIP, model.getSiteID()), this.llvdTrip);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DC_AIRCON_COMPRESSOR_FAN_FAULT, model.getSiteID()), this.dcAirConCompressorFanFault);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SINGLE_RECTIFIER_FAIL, model.getSiteID()), this.singleRectifierFault);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.MULTIPLE_RECTIFIER_FAIL, model.getSiteID()), this.multipleRectifierFault);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.FUEL_ADDITION, model.getSiteID()), this.fuelAdditionAlarm);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.FUEL_PILFERAGE, model.getSiteID()), this.fuelPilferageAlarm);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.AC_SURGE_PROTECTION_DEVICE_FAIL, model.getSiteID()), this.aCSurgeProtectionDeviceFail);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DC_SURGE_PROTECTION_DEVICE_FAIL, model.getSiteID()), this.dCSurgeProtectionDeviceFail);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.AIRCON_FAIL, model.getSiteID()), this.airConFail);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SYSTEM_CONTROLLER_DI5, model.getSiteID()), this.ebFail);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.SOC_BATTERY_1, model.getSiteID()), this.socBattery1);
        Constants.siteWiseAlarmsStatusMap.put(generateRedisKey(Util.AlarmNames.DC_VOLTAGE_HIGH, model.getSiteID()), this.dcVoltageHigh);

    }

    public double calculateKW(double value) {
        return value / 1000;
    }

    public int getOneIfGreateThanZero(float val) {
        return (val > 0) ? 1 : 0;
    }

    public String getLastUpdated() {
        return lastUpdated;
    }

    public void setLastUpdated(String lastUpdated) {
        this.lastUpdated = lastUpdated;
    }

    public Integer getPacketId() {
        return packetId;
    }

    public void setPacketId(Integer packetId) {
        this.packetId = packetId;
    }

    public String getSiteId() {
        return siteId;
    }

    public void setSiteId(String siteId) {
        this.siteId = siteId;
    }

    public String getSiteName() {
        return siteName;
    }

    public void setSiteName(String siteName) {
        this.siteName = siteName;
    }

    public String getEnergyModel() {
        return energyModel;
    }

    public void setEnergyModel(String energyModel) {
        this.energyModel = energyModel;
    }

    public String getBatteryDischarge() {
        return batteryDischarge;
    }

    public void setBatteryDischarge(String batteryDischarge) {
        this.batteryDischarge = batteryDischarge;
    }

    public String getBatteryFuseFail() {
        return batteryFuseFail;
    }

    public void setBatteryFuseFail(String batteryFuseFail) {
        this.batteryFuseFail = batteryFuseFail;
    }

    public String getBlvdAlarm() {
        return blvdAlarm;
    }

    public void setBlvdAlarm(String blvdAlarm) {
        this.blvdAlarm = blvdAlarm;
    }

    public String getDcVoltageLow() {
        return dcVoltageLow;
    }

    public void setDcVoltageLow(String dcVoltageLow) {
        this.dcVoltageLow = dcVoltageLow;
    }

    public String getDgBatteryLow() {
        return dgBatteryLow;
    }

    public void setDgBatteryLow(String dgBatteryLow) {
        this.dgBatteryLow = dgBatteryLow;
    }

    public String getDgFailToStart() {
        return dgFailToStart;
    }

    public void setDgFailToStart(String dgFailToStart) {
        this.dgFailToStart = dgFailToStart;
    }

    public String getDgManualMode() {
        return dgManualMode;
    }

    public void setDgManualMode(String dgManualMode) {
        this.dgManualMode = dgManualMode;
    }

    public String getDoorOpenAlarm() {
        return doorOpenAlarm;
    }

    public void setDoorOpenAlarm(String doorOpenAlarm) {
        this.doorOpenAlarm = doorOpenAlarm;
    }

    public String getLoadBreakerFail() {
        return loadBreakerFail;
    }

    public void setLoadBreakerFail(String loadBreakerFail) {
        this.loadBreakerFail = loadBreakerFail;
    }

    public String getLoadOnDG() {
        return loadOnDG;
    }

    public void setLoadOnDG(String loadOnDG) {
        this.loadOnDG = loadOnDG;
    }

    public String getLoadOnSolar() {
        return loadOnSolar;
    }

    public void setLoadOnSolar(String loadOnSolar) {
        this.loadOnSolar = loadOnSolar;
    }

    public String getLowFuelLevel() {
        return lowFuelLevel;
    }

    public void setLowFuelLevel(String lowFuelLevel) {
        this.lowFuelLevel = lowFuelLevel;
    }

    public String getMainsFailure() {
        return mainsFailure;
    }

    public void setMainsFailure(String mainsFailure) {
        this.mainsFailure = mainsFailure;
    }

    public String getMainsOnBatteryDischarge() {
        return mainsOnBatteryDischarge;
    }

    public void setMainsOnBatteryDischarge(String mainsOnBatteryDischarge) {
        this.mainsOnBatteryDischarge = mainsOnBatteryDischarge;
    }

    public String getRectifierCommunicationFailure() {
        return rectifierCommunicationFailure;
    }

    public void setRectifierCommunicationFailure(String rectifierCommunicationFailure) {
        this.rectifierCommunicationFailure = rectifierCommunicationFailure;
    }

    public String getRectifierFail() {
        return rectifierFail;
    }

    public void setRectifierFail(String rectifierFail) {
        this.rectifierFail = rectifierFail;
    }

    public String getSiteOnBattery() {
        return siteOnBattery;
    }

    public void setSiteOnBattery(String siteOnBattery) {
        this.siteOnBattery = siteOnBattery;
    }

    public String getSmokeAndFire() {
        return smokeAndFire;
    }

    public void setSmokeAndFire(String smokeAndFire) {
        this.smokeAndFire = smokeAndFire;
    }

    public String getSolarControllerFail() {
        return solarControllerFail;
    }

    public void setSolarControllerFail(String solarControllerFail) {
        this.solarControllerFail = solarControllerFail;
    }

    public String getHighTemperature() {
        return highTemperature;
    }

    public void setHighTemperature(String highTemperature) {
        this.highTemperature = highTemperature;
    }

    public String getRegion() {
        return region;
    }

    public void setRegion(String region) {
        this.region = region;
    }

    public String getZone() {
        return zone;
    }

    public void setZone(String zone) {
        this.zone = zone;
    }

    public String getCluster() {
        return cluster;
    }

    public void setCluster(String cluster) {
        this.cluster = cluster;
    }

    public String getClientSiteId() {
        return clientSiteId;
    }

    public void setClientSiteId(String clientSiteId) {
        this.clientSiteId = clientSiteId;
    }

    public float getDcV() {
        return dcV;
    }

    public void setDcV(float dcV) {
        this.dcV = dcV;
    }

    public Integer getFuel() {
        return fuel;
    }

    public void setFuel(Integer fuel) {
        this.fuel = fuel;
    }

    public String getPowerSource() {
        return powerSource;
    }

    public void setPowerSource(String powerSource) {
        this.powerSource = powerSource;
    }

    public String getSoc() {
        return soc;
    }

    public void setSoc(String soc) {
        this.soc = soc;
    }

    public float getDcKW() {
        return dcKW;
    }

    public void setDcKW(float dcKW) {
        this.dcKW = dcKW;
    }

    public boolean isSolar() {
        return isSolar;
    }

    public void setSolar(boolean isSolar) {
        this.isSolar = isSolar;
    }

    public String getSolarHybridMode() {
        return solarHybridMode;
    }

    public void setSolarHybridMode(String solarHybridMode) {
        this.solarHybridMode = solarHybridMode;
    }

    public long getLastUpdate() {
        return lastUpdate;
    }

    public void setLastUpdate(long lastUpdate) {
        this.lastUpdate = lastUpdate;
    }

    public List<String> getTickersList() {
        return tickersList;
    }

    public void setTickersList(List<String> tickersList) {
        this.tickersList = tickersList;
    }

    public Integer getContractParent() {
        return contractParent;
    }

    public void setContractParent(Integer contractParent) {
        this.contractParent = contractParent;
    }

    public String getRectifierControllerCommFault() {
        return rectifierControllerCommFault;
    }

    public void setRectifierControllerCommFault(String rectifierControllerCommFault) {
        this.rectifierControllerCommFault = rectifierControllerCommFault;
    }

    public String getAcemCommFault() {
        return acemCommFault;
    }

    public void setAcemCommFault(String acemCommFault) {
        this.acemCommFault = acemCommFault;
    }

    public String getDcemCommFault() {
        return dcemCommFault;
    }

    public void setDcemCommFault(String dcemCommFault) {
        this.dcemCommFault = dcemCommFault;
    }

    public String getGcuCommFault() {
        return gcuCommFault;
    }

    public void setGcuCommFault(String gcuCommFault) {
        this.gcuCommFault = gcuCommFault;
    }

    public String getSolarEmCommFault() {
        return solarEmCommFault;
    }

    public void setSolarEmCommFault(String solarEmCommFault) {
        this.solarEmCommFault = solarEmCommFault;
    }

    public String getFuelSensorCommFault() {
        return fuelSensorCommFault;
    }

    public void setFuelSensorCommFault(String fuelSensorCommFault) {
        this.fuelSensorCommFault = fuelSensorCommFault;
    }

    public String getGpsLatitude() {
        return gpsLatitude;
    }

    public void setGpsLatitude(String gpsLatitude) {
        this.gpsLatitude = gpsLatitude;
    }

    public String getGpsLongitude() {
        return gpsLongitude;
    }

    public void setGpsLongitude(String gpsLongitude) {
        this.gpsLongitude = gpsLongitude;
    }

    public Integer getWifiStatus() {
        return wifiStatus;
    }

    public void setWifiStatus(Integer wifiStatus) {
        this.wifiStatus = wifiStatus;
    }

    public String getPacketType() {
        return packetType;
    }

    public void setPacketType(String packetType) {
        this.packetType = packetType;
    }

    public float getTotalDcLoadCurrent() {
        return totalDcLoadCurrent;
    }

    public void setTotalDcLoadCurrent(float totalDcLoadCurrent) {
        this.totalDcLoadCurrent = totalDcLoadCurrent;
    }

    public double getDcLoadPowerKW() {
        return dcLoadPowerKW;
    }

    public void setDcLoadPowerKW(double dcLoadPowerKW) {
        this.dcLoadPowerKW = dcLoadPowerKW;
    }

    public Integer getBatteryCapacity() {
        return batteryCapacity;
    }

    public void setBatteryCapacity(Integer batteryCapacity) {
        this.batteryCapacity = batteryCapacity;
    }

    public Integer getBatteryCurrent() {
        return batteryCurrent;
    }

    public void setBatteryCurrent(Integer batteryCurrent) {
        this.batteryCurrent = batteryCurrent;
    }

    public float getBatteryRunhours() {
        return (this.batteryRunhours);
    }

    public void setBatteryRunhours(float batteryRunhours) {
        this.batteryRunhours = batteryRunhours;
    }

    public float getBatteryDischargeEnergy() {
        return (batteryDischargeEnergy);
    }

    public void setBatteryDischargeEnergy(float batteryDischargeEnergy) {
        this.batteryDischargeEnergy = batteryDischargeEnergy;
    }

    public double getDgPowerKW() {
        return (dgPowerKW);
    }

    public void setDgPowerKW(double dgPowerKW) {
        this.dgPowerKW = dgPowerKW;
    }

    public float getDgEnergy() {
        return dgEnergy;
    }

    public void setDgEnergy(float dgEnergy) {
        this.dgEnergy = dgEnergy;
    }

    public float getDgRunhours() {
        return (dgRunhours);
    }

    public void setDgRunhours(float dgRunhours) {
        this.dgRunhours = dgRunhours;
    }

    public float getDgBatteryVoltage() {
        return dgBatteryVoltage;
    }

    public void setDgBatteryVoltage(float dgBatteryVoltage) {
        this.dgBatteryVoltage = dgBatteryVoltage;
    }

    public double getGridPowerKW() {
        return gridPowerKW;
    }

    public void setGridPowerKW(double gridPowerKW) {
        this.gridPowerKW = gridPowerKW;
    }

    public float getGridEnergy() {
        return gridEnergy;
    }

    public void setGridEnergy(float gridEnergy) {
        this.gridEnergy = gridEnergy;
    }

    public float getGridRunhours() {
        return gridRunhours;
    }

    public void setGridRunhours(float gridRunhours) {
        this.gridRunhours = gridRunhours;
    }

    public double getPvTotalCurrent() {
        return pvTotalCurrent;
    }

    public void setPvTotalCurrent(double pvTotalCurrent) {
        this.pvTotalCurrent = pvTotalCurrent;
    }

    public double getPvTotalPowerInKW() {
        return pvTotalPowerInKW;
    }

    public void setPvTotalPowerInKW(double pvTotalPowerInKW) {
        this.pvTotalPowerInKW = pvTotalPowerInKW;
    }

    public float getPvEnergy() {
        return pvEnergy;
    }

    public void setPvEnergy(float pvEnergy) {
        this.pvEnergy = pvEnergy;
    }

    public float getPvRunhours() {
        return pvRunhours;
    }

    public void setPvRunhours(float pvRunhours) {
        this.pvRunhours = pvRunhours;
    }

    public float getShelterTemperature() {
        return shelterTemperature;
    }

    public void setShelterTemperature(float shelterTemperature) {
        this.shelterTemperature = shelterTemperature;
    }

    public float getAmbientTemperature() {
        return ambientTemperature;
    }

    public void setAmbientTemperature(float ambientTemperature) {
        this.ambientTemperature = ambientTemperature;
    }

    public float getBatteryCabinetTemperature() {
        return batteryCabinetTemperature;
    }

    public void setBatteryCabinetTemperature(float batteryCabinetTemperature) {
        this.batteryCabinetTemperature = batteryCabinetTemperature;
    }

    public String getSystemControllerFirmwareVersion() {
        return systemControllerFirmwareVersion;
    }

    public void setSystemControllerFirmwareVersion(String systemControllerFirmwareVersion) {
        this.systemControllerFirmwareVersion = systemControllerFirmwareVersion;
    }

    public String getRmsFirmwareVersion() {
        return rmsFirmwareVersion;
    }

    public void setRmsFirmwareVersion(String rmsFirmwareVersion) {
        this.rmsFirmwareVersion = rmsFirmwareVersion;
    }

    public String getBatteryFault() {
        return batteryFault;
    }

    public void setBatteryFault(String batteryFault) {
        this.batteryFault = batteryFault;
    }

    public String getRectifierModuleFail() {
        return rectifierModuleFail;
    }

    public void setRectifierModuleFail(String rectifierModuleFail) {
        this.rectifierModuleFail = rectifierModuleFail;
    }

    public String getPvModuleFail() {
        return pvModuleFail;
    }

    public void setPvModuleFail(String pvModuleFail) {
        this.pvModuleFail = pvModuleFail;
    }

    public String getDgCommonFault() {
        return dgCommonFault;
    }

    public void setDgCommonFault(String dgCommonFault) {
        this.dgCommonFault = dgCommonFault;
    }

    public String getSurgeProtectionDeviceFail() {
        return surgeProtectionDeviceFail;
    }

    public void setSurgeProtectionDeviceFail(String surgeProtectionDeviceFail) {
        this.surgeProtectionDeviceFail = surgeProtectionDeviceFail;
    }

    public String getLiCommFault() {
        return liCommFault;
    }

    public void setLiCommFault(String liCommFault) {
        this.liCommFault = liCommFault;
    }

    public String getDcAirCon1CommFault() {
        return dcAirCon1CommFault;
    }

    public void setDcAirCon1CommFault(String dcAirCon1CommFault) {
        this.dcAirCon1CommFault = dcAirCon1CommFault;
    }

    public String getDcAirCon2CommFault() {
        return dcAirCon2CommFault;
    }

    public void setDcAirCon2CommFault(String dcAirCon2CommFault) {
        this.dcAirCon2CommFault = dcAirCon2CommFault;
    }

    public String getDgEmergencyStop() {
        return dgEmergencyStop;
    }

    public void setDgEmergencyStop(String dgEmergencyStop) {
        this.dgEmergencyStop = dgEmergencyStop;
    }

    public String getDgOverLoad() {
        return dgOverLoad;
    }

    public void setDgOverLoad(String dgOverLoad) {
        this.dgOverLoad = dgOverLoad;
    }

    public String getDgOnWithoutLoud() {
        return dgOnWithoutLoud;
    }

    public void setDgOnWithoutLoud(String dgOnWithoutLoud) {
        this.dgOnWithoutLoud = dgOnWithoutLoud;
    }

    public String getDgFailToStop() {
        return dgFailToStop;
    }

    public void setDgFailToStop(String dgFailToStop) {
        this.dgFailToStop = dgFailToStop;
    }

    public String getDgLlop() {
        return dgLlop;
    }

    public void setDgLlop(String dgLlop) {
        this.dgLlop = dgLlop;
    }

    public String getDgHwt() {
        return dgHwt;
    }

    public void setDgHwt(String dgHwt) {
        this.dgHwt = dgHwt;
    }

    public String getGpsFixed() {
        return gpsFixed;
    }

    public void setGpsFixed(String gpsFixed) {
        this.gpsFixed = gpsFixed;
    }

    public String getFanFail() {
        return fanFail;
    }

    public void setFanFail(String fanFail) {
        this.fanFail = fanFail;
    }

    public String getSystemInManualMode() {
        return systemInManualMode;
    }

    public void setSystemInManualMode(String systemInManualMode) {
        this.systemInManualMode = systemInManualMode;
    }

    public String getSystemBatterytemp4HighAlarm() {
        return this.systemBatterytemp4HighAlarm;
    }

    public void setSystemBatterytemp4HighAlarm(String systemBatterytemp4HighAlarm) {
        this.systemBatterytemp4HighAlarm = systemBatterytemp4HighAlarm;
    }

    public String getTemperatureSensorLoseorFaultAlarm() {
        return this.temperatureSensorLoseorFaultAlarm;
    }

    public void setTemperatureSensorLoseorFaultAlarm(String temperatureSensorLoseorFaultAlarm) {
        this.temperatureSensorLoseorFaultAlarm = temperatureSensorLoseorFaultAlarm;
    }

    public String getTamperSwitch() {
        return tamperSwitch;
    }

    public void setTamperSwitch(String tamperSwitch) {
        this.tamperSwitch = tamperSwitch;
    }

    // public String getDcHvModuleDisconnect() { return dcHvModuleDisconnect; }

    //public void setDcHvModuleDisconnect(String dcHvModuleDisconnect) { this.dcHvModuleDisconnect = dcHvModuleDisconnect; }

    //public String getHighTemperatureModuleShutdown() { return highTemperatureModuleShutdown; }

    //public void setHighTemperatureModuleShutdown(String highTemperatureModuleShutdown) { this.highTemperatureModuleShutdown = highTemperatureModuleShutdown; }

    public String getBlvdTrip() {
        return blvdTrip;
    }

    public void setBlvdTrip(String blvdTrip) {
        this.blvdTrip = blvdTrip;
    }

    public String getLlvdTrip() {
        return llvdTrip;
    }

    public void setLlvdTrip(String llvdTrip) {
        this.llvdTrip = llvdTrip;
    }

    public String getDcAirConCompressorFanFault() {
        return dcAirConCompressorFanFault;
    }

    public void setDcAirConCompressorFanFault(String dcAirConCompressorFanFault) {
        this.dcAirConCompressorFanFault = dcAirConCompressorFanFault;
    }

    public String getSingleRectifierFault() {
        return singleRectifierFault;
    }

    public void setSingleRectifierFault(String singleRectifierFault) {
        this.singleRectifierFault = singleRectifierFault;
    }

    public String getMultipleRectifierFault() {
        return multipleRectifierFault;
    }

    public void setMultipleRectifierFault(String multipleRectifierFault) {
        this.multipleRectifierFault = multipleRectifierFault;
    }

    public String getFuelAdditionAlarm() {
        return fuelAdditionAlarm;
    }

    public void setFuelAdditionAlarm(String fuelAdditionAlarm) {
        this.fuelAdditionAlarm = fuelAdditionAlarm;
    }

    public String getFuelPilferageAlarm() {
        return fuelPilferageAlarm;
    }

    public void setFuelPilferageAlarm(String fuelPilferageAlarm) {
        this.fuelPilferageAlarm = fuelPilferageAlarm;
    }

    public String getClientId() {
        return clientId;
    }

    public void setClientId(String clientId) {
        this.clientId = clientId;
    }

    public String getTenantName() {
        return tenantName;
    }

    public void setTenantName(String tenantName) {
        this.tenantName = tenantName;
    }

    public String getaCSurgeProtectionDeviceFail() {
        return aCSurgeProtectionDeviceFail;
    }

    public void setaCSurgeProtectionDeviceFail(String aCSurgeProtectionDeviceFail) {
        this.aCSurgeProtectionDeviceFail = aCSurgeProtectionDeviceFail;
    }

    public String getdCSurgeProtectionDeviceFail() {
        return dCSurgeProtectionDeviceFail;
    }

    public void setdCSurgeProtectionDeviceFail(String dCSurgeProtectionDeviceFail) {
        this.dCSurgeProtectionDeviceFail = dCSurgeProtectionDeviceFail;
    }

    public String getAirConFail() {
        return airConFail;
    }

    public void setAirConFail(String airConFail) {
        this.airConFail = airConFail;
    }

    public String getEbFail() {
        return ebFail;
    }

    public void setEbFail(String ebFail) {
        this.ebFail = ebFail;
    }


    public String getModuleSerialNumber1() {
        return moduleSerialNumber1;
    }

    public void setModuleSerialNumber1(String moduleSerialNumber1) {
        this.moduleSerialNumber1 = moduleSerialNumber1;
    }

    public String getModuleSerialNumber2() {
        return moduleSerialNumber2;
    }

    public void setModuleSerialNumber2(String moduleSerialNumber2) {
        this.moduleSerialNumber2 = moduleSerialNumber2;
    }

    public String getModuleSerialNumber3() {
        return moduleSerialNumber3;
    }

    public void setModuleSerialNumber3(String moduleSerialNumber3) {
        this.moduleSerialNumber3 = moduleSerialNumber3;
    }

    public String getModuleSerialNumber4() {
        return moduleSerialNumber4;
    }

    public void setModuleSerialNumber4(String moduleSerialNumber4) {
        this.moduleSerialNumber4 = moduleSerialNumber4;
    }

    public String getModuleSerialNumber5() {
        return moduleSerialNumber5;
    }

    public void setModuleSerialNumber5(String moduleSerialNumber5) {
        this.moduleSerialNumber5 = moduleSerialNumber5;
    }

    public String getModuleSerialNumber6() {
        return moduleSerialNumber6;
    }

    public void setModuleSerialNumber6(String moduleSerialNumber6) {
        this.moduleSerialNumber6 = moduleSerialNumber6;
    }

    public String getModuleSerialNumber7() {
        return moduleSerialNumber7;
    }

    public void setModuleSerialNumber7(String moduleSerialNumber7) {
        this.moduleSerialNumber7 = moduleSerialNumber7;
    }

    public String getModuleSerialNumber8() {
        return moduleSerialNumber8;
    }

    public void setModuleSerialNumber8(String moduleSerialNumber8) {
        this.moduleSerialNumber8 = moduleSerialNumber8;
    }

    public String getModuleSerialNumber9() {
        return moduleSerialNumber9;
    }

    public void setModuleSerialNumber9(String moduleSerialNumber9) {
        this.moduleSerialNumber9 = moduleSerialNumber9;
    }

    public String getModuleSerialNumber10() {
        return moduleSerialNumber10;
    }

    public void setModuleSerialNumber10(String moduleSerialNumber10) {
        this.moduleSerialNumber10 = moduleSerialNumber10;
    }

    public String getModuleSerialNumber11() {
        return moduleSerialNumber11;
    }

    public void setModuleSerialNumber11(String moduleSerialNumber11) {
        this.moduleSerialNumber11 = moduleSerialNumber11;
    }

    public String getModuleSerialNumber12() {
        return moduleSerialNumber12;
    }

    public void setModuleSerialNumber12(String moduleSerialNumber12) {
        this.moduleSerialNumber12 = moduleSerialNumber12;
    }

    public String getModuleSerialNumber13() {
        return moduleSerialNumber13;
    }

    public void setModuleSerialNumber13(String moduleSerialNumber13) {
        this.moduleSerialNumber13 = moduleSerialNumber13;
    }

    public String getModuleSerialNumber14() {
        return moduleSerialNumber14;
    }

    public void setModuleSerialNumber14(String moduleSerialNumber14) {
        this.moduleSerialNumber14 = moduleSerialNumber14;
    }

    public String getModuleSerialNumber15() {
        return moduleSerialNumber15;
    }

    public void setModuleSerialNumber15(String moduleSerialNumber15) {
        this.moduleSerialNumber15 = moduleSerialNumber15;
    }

    public String getModuleSerialNumber16() {
        return moduleSerialNumber16;
    }

    public void setModuleSerialNumber16(String moduleSerialNumber16) {
        this.moduleSerialNumber16 = moduleSerialNumber16;
    }

    public String getModuleSerialNumber17() {
        return moduleSerialNumber17;
    }

    public void setModuleSerialNumber17(String moduleSerialNumber17) {
        this.moduleSerialNumber17 = moduleSerialNumber17;
    }

    public String getModuleSerialNumber18() {
        return moduleSerialNumber18;
    }

    public void setModuleSerialNumber18(String moduleSerialNumber18) {
        this.moduleSerialNumber18 = moduleSerialNumber18;
    }

    public String getModuleSerialNumber19() {
        return moduleSerialNumber19;
    }

    public void setModuleSerialNumber19(String moduleSerialNumber19) {
        this.moduleSerialNumber19 = moduleSerialNumber19;
    }

    public String getModuleSerialNumber20() {
        return moduleSerialNumber20;
    }

    public void setModuleSerialNumber20(String moduleSerialNumber20) {
        this.moduleSerialNumber20 = moduleSerialNumber20;
    }

    public String getSocBattery1() {
        return socBattery1;
    }

    public void setSocBattery1(String socBattery1) {
        this.socBattery1 = socBattery1;
    }


}
