package com.ieng.rms.services;

import com.ieng.rms.dto.EscoConfigDTO;
import com.ieng.rms.models.SiteDetailsDTO;
import com.ieng.rms.util.Constants;
import com.ieng.rms.util.Util;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class CommonService {

    @Autowired
    RmsCoreClientService rmsCoreClientService;

    public EscoConfigDTO getEscoConfigByProtocolName() {
        return rmsCoreClientService.getEscoConfigByProtocolName(Constants.PROTOCOL_NAME);
    }

    public List<SiteDetailsDTO> getAllProtocolSites(){
        EscoConfigDTO escoConfigDTO = getEscoConfigByProtocolName();
        List<SiteDetailsDTO> siteDetailsDTOList = new ArrayList<>();
        if(escoConfigDTO != null && !escoConfigDTO.getContractIds().isEmpty()) {
            escoConfigDTO.getContractIds().forEach(contract -> {
                siteDetailsDTOList.addAll(rmsCoreClientService.getAllSitesByContractId(contract));
            });
        }else{
            throw new RuntimeException("Contract Details are missing in ESCO Configuration");
        }
        return siteDetailsDTOList;
    }

    public SiteDetailsDTO getSiteDetailsBySiteId(String siteDetail){
        return Constants.siteDetailsMap.get(siteDetail);
    }

}
