package com.ieng.rms.util;

import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Locale;

public class Conversion {
	private Conversion() {

	}

	public final static java.util.Date convertStringToDate(String pydSpdtvalue, String dateFormat, Locale locale)
			throws Exception {

		if (locale == null) {
			locale = Locale.getDefault();
		}
		try {
			return new SimpleDateFormat(dateFormat, locale).parse(pydSpdtvalue);
		} catch (ParseException e) {
			e.printStackTrace();
			throw e;
		}

	}
	
	
	public static float round(float d, int decimalPlace) {
	    BigDecimal bd = new BigDecimal(Float.toString(d));
	    bd = bd.setScale(decimalPlace, BigDecimal.ROUND_HALF_UP);
	    return bd.floatValue();
	}

	public static float getFloatValue(String value){
		return Float.parseFloat(value);
	}

	public static Integer getIntegerValue(String value){
		return Integer.parseInt(value);
	}

}
