package com.ieng.rms.util;

import com.ieng.rms.entity.AlarmDetailConfig;
import com.ieng.rms.models.PacketModel;

import java.util.List;
import java.util.Map;

public class Util {

    public static final class AlarmStatus {
        private AlarmStatus() {
        }

        public static final String MAJOR_ALARM = "Major";
        public static final String MINOR_ALARM = "Minor";
        public static final String CRITICAL_ALARM = "Critical";
        public static final String NORMAL_ALARM = "Normal";
        public static final String ACTIVE_ALARM = "1";
        public static final String DISABLED_ALARM = "0";
    }

    public static final class AlarmNames {

        public static final String ACEM_COMM_FAULT = "ACEM_Comm_Fault";
        public static final String BATTERY_FAULT = "Battery_Fault";
        public static final String BATTERY_FUSE_FAIL = "Battery_Fuse_Fail";
        public static final String BATTERY_ON_DISCHARGE = "Battery_On_discharge";
        public static final String BATTER_TEMP_HIGH = "Batter_Temp_High";
        public static final String BLVD_TRIP = "BLVD_Trip";
        public static final String DCEM_COMM_FAULT = "DCEM_Comm_Fault";
        public static final String DC_AIRCON1_COMM_FAULT = "DC_AirCon1_Comm_Fault";
        public static final String DC_AIRCON_2_COMM_FAULT = "DC_Aircon_2_Comm_Fault";
        public static final String DC_AIRCON_COMPRESSOR_FAN_FAULT = "DC_Aircon_Compressor_Fan_fault";
        public static final String DC_HV_MODULE_DISCONNECT = "DC_HV_module_Disconnect";
        public static final String DC_VOLTAGE_LOW = "DC_Voltage_Low";
        public static final String DG_BATTERY_VOLTAGE_LOW = "DG_Battery_Voltage_Low";
        public static final String DG_COMMON_FAULT = "DG_Common_Fault";
        public static final String DG_EMERGENCY_STOP = "DG_Emergency_Stop";
        public static final String DG_FAIL_TO_START = "DG_Fail_To_Start";
        public static final String DG_FAIL_TO_STOP = "DG_Fail_To_Stop";
        public static final String DG_HWT = "DG_HWT";
        public static final String DG_LLOP = "DG_LLOP";
        public static final String DG_LOW_FUEL_LEVEL = "DG_Low_Fuel_Level";
        public static final String DG_ON_WITHOUT_LOAD = "DG_On_Without_load";
        public static final String DG_OVER_LOAD = "DG_Over_Load";
        public static final String DG_RUNNING_IN_MANUAL_MODE = "DG_Running_In_Manual_Mode";
        public static final String DOOR_OPEN = "DOOR_OPEN";
        public static final String FAN_FAIL = "Fan_Fail";
        public static final String FUEL_ADDITION = "FUEL_ADDITION";
        public static final String FUEL_PILFERAGE = "Fuel_Pilferage";
        public static final String FUEL_SENSOR_COMM_FAULT = "Fuel_Sensor_Comm_Fault";
        public static final String GCU_COMM_FAULT = "GCU_Comm_Fault";
        public static final String GPS_FIXED = "GPS_Fixed";
        public static final String HIGH_TEMP_MODULE_SHUTDOWN = "High_Temp_Module_Shutdown";
        public static final String LI_COMM_FAULT = "Li_Comm_Fault";
        public static final String LLVD_OR_LVBD_TRIP = "LLVD_Or_LVBD_Trip";
        public static final String LLVD_TRIP = "LLVD_Trip";
        public static final String LOAD_BREAKER_TRIPPED = "Load_Breaker_Tripped";
        public static final String MAINS_FAIL = "Mains_Fail";
        public static final String MULTIPLE_RECTIFIER_FAIL = "Multiple_Rectifier_Fail";
        public static final String PV_EM_COMM_FAULT = "PV_EM_Comm_fault";
        public static final String SOLAR_CONTROLLER_FAIL = "Solar_Controller_Fail";
        public static final String PV_MODULE_FAIL = "PV_Module_Fail";
        public static final String RECTIFIER_CONTROLLER_COMMUNICATION_FAULT = "Rectifier_Controller_Communication_Fault";
        public static final String RECTIFIER_MODULE_FAIL = "Rectifier_Module_Fail";
        public static final String SINGLE_RECTIFIER_FAIL = "Single_Rectifier_Fail";
        public static final String SMOKE_FIRE = "Smoke_Fire";
        public static final String SYSTEM_BATTERY_TEMP4_HIGH = "System_Battery_Temp4_High";
        public static final String TEMPERATURE_SENSOR_LOSE_OR_FAULT_ALARM = "Temperature_Sensor_Lose_or_Fault_Alarm";
        public static final String SURGE_PROTECTION_DEVICE_FAIL = "Surge_Protection_Device_Fail";
        public static final String SYSTEM_IN_MANUAL_MODE = "System_In_Manual_Mode";
        public static final String TAMPER_SWITCH = "Tamper_Switch";
        public static final String LOAD_ON_DG = "Load_On_DG";
        public static final String LOAD_ON_SOLAR = "Load_On_Solar";
        public static final String SOLAR_HYBRID_MODE = "Solar_Hybrid_Mode";
        public static final String SITE_ON_BATTERY = "Site_On_Battery";
        public static final String MAINS_ON_BATTERY_DISCHARGE = "Mains_On_Battery_Discharge";
        public static final String AC_SURGE_PROTECTION_DEVICE_FAIL = "Ac_Surge_Device_Fail";
        public static final String DC_SURGE_PROTECTION_DEVICE_FAIL = "Dc_Surge_Device_Fail";
        public static final String AIRCON_FAIL = "Aircon_Fail";
        public static final String SYSTEM_CONTROLLER_DI5 = "EB_Fail";
        public static final String SOC_BATTERY_1 = "Soc_Battery_1";
        public static final String FAN_FailDI1 = "DI1";
        public static final String DOOR_OPENDI2 = "DI2";
        public static final String SMOKE_FIREDI3 = "DI3";
        public static final String SPARE_DI4 = "DI4";
        public static final String SPARE_DI5 = "DI5";
        public static final String SPARE_DI6 = "DI6";
        public static final String SPARE_DI7 = "DI7";
        public static final String SPARE_DI8 = "DI8";
        public static final String SPARE_DI9 = "DI9";
        public static final String SPARE_DI10 = "DI10";
        public static final String SPARE_DI11 = "DI11";
        public static final String SPARE_DI12 = "DI12";
        public static final String SPARE_DI13 = "DI13";
        public static final String SPARE_DI14 = "DI14";
        public static final String SPARE_DI15 = "DI15";
        public static final String SPARE_DI16 = "DI16";
        public static final String DC_VOLTAGE_HIGH = "DC_Voltage_High";


    }

    public static String addUnderscoreAgainstSpace(String value) {
        return value.replace(' ', '_');
    }

//    public static Integer getAlarmsStatusOf(AlarmDetailConfig alarmConfig, Map<String, Object> packetModelMap) {
//        int alarmStatus = 0;
//        try {
//            alarmStatus = Integer.parseInt(String.valueOf(packetModelMap.get(alarmConfig.getObjectProperty().trim())));
//        } catch (Exception ex) {
//        }
//        return alarmStatus;
//
//    }

    public static Integer getAlarmsStatusOf(AlarmDetailConfig alarmConfig, PacketModel model, Map<String, Object> packetModelMap) {
        Integer alarmStatus = 0;
        try {
            alarmStatus = Integer.valueOf(String.valueOf(packetModelMap.get(alarmConfig.getObjectProperty().trim())));

        } catch (Exception ex) {
            alarmStatus = 0;
//			System.out.println("Packet Sequence: " + model.getPacketSeqid() + ",DateTime: "+ model.getDateAndTimeStamp() +"SiteId:"+model.getSiteID()+ ", AlarmName: "+alarmConfig.getAlarmName()+",contractId:"+alarmConfig.getContractId());
//			ex.printStackTrace();
        }
        return alarmStatus;

    }

    public static String removeUnderscoreWithSpace(String value) {
        return value.replace('_', ' ');
    }

//    public static String removeSpaceWithSUnderscore(String value) {
//        return value.replace(' ', '_');
//    }

    public static String getAlarmCriticality(String alarmName, List<AlarmDetailConfig> alarmList) {
        // Find the AlarmConfigDto matching the alarmName
        return alarmList.stream()
                .filter(alarm -> alarm.getAlarmName().equals(alarmName))
                .findFirst()
                .map(AlarmDetailConfig::getCriticality)
                .orElse(AlarmStatus.NORMAL_ALARM); // Return default value if not found
    }

    public static String getAlarmCriticality(String alarmName, Map<String, String> alarmMap) {
        String alarmCriticality = alarmMap.get(alarmName);
        if (alarmCriticality == null) {
            alarmCriticality = AlarmStatus.NORMAL_ALARM;
        }
        return alarmCriticality;
    }

    public static Boolean checkSonicVersion(String rmsFirmwareVersion) {

        String[] versionParts = rmsFirmwareVersion.split("\\.");
        int majorVersion = versionParts.length > 0 ? Integer.parseInt(versionParts[0]) : 0;
        int minorVersion = versionParts.length > 1 ? Integer.parseInt(versionParts[1]) : 0;
        return majorVersion > 6 || (majorVersion == 6 && minorVersion >= 11);
    }


    public static String removeContractIdFromKey(String key) {
        return key.substring(0, key.length() - 3);
    }


}
